Index: Tst/Short/string.res.gz.uu
===================================================================
--- Tst/Short/string.res.gz.uu	(revision 0df02761ea5104747ff923eee578ddb4d27f4a45)
+++ Tst/Short/string.res.gz.uu	(revision 458bd67f21def86763df6137584fe9c0d9fa9a66)
@@ -1,27 +1,44 @@
 begin 644 string.res.gz
-M'XL(""SF%C<``W-T<FEN9RYR97,`[5A?;]LV$'_7ISAX>Y`W)A$IV4[L1<.6
-MO008]I*]&4'M6$S-1I9DBFYM#_ONNZ-L4G:3SEW7H=@6(!'O=/S=_Q.9NU]_
-MNOT%`'@*/]_^"!U3F_-</71&P=WNC4@!F:]4H4S8'07TA+3AU69J5O5YN3).
-M.D[!K9-SR%5M((=KX`S$"&JC5?$ZS!&',^$$>^E.,/=J^ZF3)G'''Z06S_ZB
-M.'*^!ZEUJ:&<S59:RPQ4`8UTK@H)@R%,6CLFM*5^4E6%V&#DVL"C+A<P@8G3
-M<8DZ1L&8WP])F`=CT:R\Q5>-%:JHI39ASL`:N7O+HX/]<E&9C770`2%D?`3)
-M>?I">#AFX"_@82;R,8_NT<R>-RTYUL)Z[AVE`7&L7^:MG(7T.F[YU2>!A`0Z
-M<^5+A`^.0.T^-E<M[,O30V)W!ZC'4G,5D!=V[>$H_N,^64(@86=>=A@:)3O>
-M6A&]9-6\9'/I;1,8>:AT.4-=\!L?_>XA!*FY)#5SY;GQI_C2;Y;[W<0M+4-X
-MA@Q0J:4N+A#YH9@N),`0=ARRU;*&A-CPS*:2=O,0:G1YE4_U,W$3Q^D_BDDU
-MU8AKI&[Z\2L4P=8;:6E6NJ#N#UIALUU;/.$?*H@+LZA\20@J%0S9WK(A_'!W
-M<WM+]*+,B*;ES@G:2F19R0+)HB1"RVEF"6.7&^*]T\K(-F^OC8;">-"4@[?A
-MDVKNQ#P-7)X._&Q8>U<;JNUMP_$.-_1[/C?L]]S^7-5Q]>'J(,L_JD1B;$&"
-M`^V2$F.SJ4Q.<_")BH73JQ`@<OS8\37RPUA$4=QEX9IMV!:?614B>=-U\HEK
-MUY9".]6N[%3SS/Y_H#0`9G-,U@QSA9ZI&6ZW$0SLNV*U>,`DEH_P=JIK>M?P
-M[<]#7LZ>R'?DESJ3-HE9U9+P/T-K?4W+-6Q@"\_@B#;.38#IL$:^PA!>1\]4
-M8CS85\D;S-M6L+5/'7:UEG69KXPJ"UQ2MF4=OF&1G_WQ%0GAZ8`W=HCFL:.B
-M0`-\=W8&1X\@B`[D=KOBH*6/(KW`,]!";?&DL9'&G4P2_[W1$DU9,[3[;"N^
-M>2V+D'>_7=N%Z#)7WPFWGVAN"U8ZXQ/Q?W%^D<5)J1K^LS45GS"17YR++&(]
-M=D(9M@X%>)#]V_5\)JMQKB]MRI8:^Z<V66@G!N%U_21(_#UB^<&/"`LW;.T^
-M)8D]47!!K;G4NVO&))^`JFVZ,OF(=XOLA.M'8N\?'LK=,I+F>-)&7A4?@7M)
-MN"VXPX_WGMV+TH-+V%*SYL@L:.WCU.,OW'F^Z%Y%@>6J-$H6ICEHV*N<K8/`
-M]N\&'^+^>NT&9FLNBJ.Q^"_Q=)]0<30Z_J3RL45/[(U>W+[]8W>.O@[X,_\2
-*^`,[&]"86Q``````
+M'XL(",)W&#<``W-T<FEN9RYR97,`[5QM;]LV$/ZN7T$8&^`TBBI2EE_G`&OW
+M)<`R#,B^I4'@Q&JC5K(<66YM#_OO.U(B>7)8UW:26G%L!#9U/-Z1S]WQ3F^Y
+M^.>/L[\((?24_'GVCM2R2>9$X4VM9UT4/>R4`/$Z'(59_:AG\5]RFM,FV2";
+M3IQDFBEN[Y2H=L/1;=\AXS2Y)>?SO]-PE-6'P4?R[6Z0'2F.ID/^50<M![Y(
+MC7.@J70$E1,5C=*<<RRD"HEZ`/5$)^K377X^;I)!YZ<'`W/]N%/W=98UVN1#
+M[=?)AQH2P.B29IL`2TU+89Y1RK@LQ3=(&6,I+:.4K"RE8Y"2(2G>`PR%E%Y)
+MBK>,)9?2PU)@LO^I@Z;V`P\F&863C$2D3ZA-6$]WM4^51T0@BLNU+NE5U^(N
+M:5VRO,4L9$)C/[:493V`?9D$&!K%6`]`6B;UOC=2KJAS2J*>D:7@:+@:F@:5
+MT$0*QP9#F"A0@GB<S05O"0M$W@("-'J]E>,!<KHHXAL0\=S($3DNK<C?-RLW
+MD'LW6OFBP]$D2&&!-A%6D[VK/!S!*76`-F\5'#\8\@B$?B!Y,]!^)$RBT]$X
+M^B[@>$G=*\#25_CY%'$P1V[)'$I%]K:'F.L337\;M-'HYP,>*7E2&V"Y$LD&
+M`MOGYO"NA&=G7X/;.K69[6G/]B$&HLL&9ZC=A3I1^*UMS2$46"!2'-V%C[+.
+M*F'/9:Q5.I_0=BO52"NTD2D[W)1-;BDNL5Z[2VJ@\"Y`V;OI/IW5FGE3CN;4
+M1!"8)@1/;-R-=?X\']AX:L_J*IO/1GH(VHF;C'M4FWM4X33:D;;>C;>>:SL_
+M>OL6)-^,!G%`2)<4%'[2(4A=.:NB(YN/`R&A2R;@"--HD.[&)9]C]I5S[N=8
+M9!7"Y%G6)2,)9>,FS\;AZ`M\\7S[-HO'.N,V129NY_N[ICYA'MX8#;'$+OG]
+MXOW964&*DV&@P2F`X0LI*,DX&`%EE!3':3`8BN-,-.<%^5L:9@$F[SAH=[/2
+M"@?X;@"IUF:P(PQDY*/:KPFU'W<5DJJ-H85*O51N#"":D-N[03JXS8(4@`EO
+M0;O'7-?+^T;3^"9(2?*1?!VD$]Z7T\7G)DINOW#H@)ZDPT!H'(X1A_YTQ>(G
+MO#DC<[(@!CD,RWE?BNM*3[04EG4QJ2.[/K/G]@)^A^,Z'+X_,L3KNKP\D"N-
+M@"$.UUU;K_)KDP&$*N$65,+A,!A$1&?>%BJ!0QE@_`LVD+Y;\F:W[#*NP366
+M:6-!,^"\S,CQU%K5Y%!5T?)5&8^V!U%-=,2)OR;NLIBHKD<`3&*2USG&.RY%
+M7B).%2YD7B*<U2J#7B2"<L=#150+BJAX`)XZ@Q]8+?S![BC2F3UC:I-LH\(J
+M'I0W?AOTS&2;7?7G>9MQ^D*V@3XK7_;G.BRNI!PH4K4A8+[3-:YA808W^<XX
+MG40V6($"!"7*-B1*J(&G44#B/DB87]F7KCT[7EQI_%#>C)?SYOS-IV!49T?'
+M_(<6D^+J)'U1-$KX4=NUB37G>LH(+HFS5XF1T&XZAF..)V!`?5.1.*>OCX@"
+M&.7^MLC](":_)AP/;!+KR\'MYHI\CS:`:^D7^E"XACPLO$,?Y@Y2WC2N3:M1
+M0TP+.NQ6*\J,@WDJ8YY'5#<'*U;&BIL550?#5<=P,INU4-YK._R&-I1SY+Q_
+M$V196(_38%*/;?<(Y;^.SG_G,O^!?4AIQQ6S8OEW.=:76&6\&\@\YDMR#-YF
+M&-:39#GC#A2?.<NY71/KXG=W$;*N^*;6R8./X'*[I5D8N+(D&T1E+JF;:MTP
+MMYN?H%FI9OQJA:C'SY7U.JON058G/H7]7GF(5KN`.5AH3VJ8@R%?;AESL)VN
+M9#IP!J]*F8XO[SU\AO2W8/9,9T`X?X>J)HFF69B,H,DO\4.5\QFJ',V$+NJG
+M@<R3L#CQR3.M/'*ME)#?3D[(TH]EN26^8I1G(>W\9F4<CL(X7`1#,@]*3QMK
+MCQ.KGEG2(19,>8#H.5FP-[G;',^4BW@EP):ND0$BAD&VZ2;+VLQX>WO\A(W7
+MX=:<"0_6GV(KY2YM7FI1*FX7!=J+.@<O.GC1NEY$7?WZ`W6INJ[^KDX=1S]=
+M3%VHZX%V)%(/?V]$]WB\AZD>IGL:O,=3/9[N\9'2IJ.U*15]JH7VF1;3]]2X
+MECS)*4;#<&HQ2S-`?!2^@SB8[M</NU/J.N1>[/KW*<QTD@WK8B?G]\CU:2BE
+M5,?6_<MX5@,8[J=)%@:C+'_PY&.:Q'F:LO(:P,KS_<MYJF/]):WW_(==G]NS
+MC9X",8ZH_+,@Z^.VR5,C1BPJ_^S(!EC(V&=HN_#*K]#=IW9^VX;Q-MHO&FN]
+M:;4G2,DTB$K_Y;../5GIZA?C]F21K\><3_(>XYY@\7JLONUKIWNR_%=D:)F-
+?T5D';3JZW7+0OT^`,Y#>+Q8U_$^%_P&\MJ]NG$$`````
 `
 end
Index: Tst/Short/string.stat
===================================================================
--- Tst/Short/string.stat	(revision 0df02761ea5104747ff923eee578ddb4d27f4a45)
+++ Tst/Short/string.stat	(revision 458bd67f21def86763df6137584fe9c0d9fa9a66)
@@ -3,9 +3,9 @@
 init >> HOSTNAME:nepomuck.mathematik.uni-kl.de
 init >> uname -a:Linux nepomuck.mathematik.uni-kl.de 2.0.33 #1 Wed Jan 21 18:50:57 MET 1998 i686 unknown
-init >> date    :Fri Apr 16 09:26:36 MET DST 1999
+init >> date    :Sat Apr 17 14:00:02 MET DST 1999
 init >> version :1302
 init >> ticks   :100
-1 >> tst_memory_0 :: nepomuck.mathematik.uni-kl.de:277613
-1 >> tst_memory_1 :: nepomuck.mathematik.uni-kl.de:337837
+1 >> tst_memory_0 :: nepomuck.mathematik.uni-kl.de:282405
+1 >> tst_memory_1 :: nepomuck.mathematik.uni-kl.de:346021
 1 >> tst_memory_2 :: nepomuck.mathematik.uni-kl.de:282624
-1 >> tst_timer_1 :: nepomuck.mathematik.uni-kl.de:8
+1 >> tst_timer_1 :: nepomuck.mathematik.uni-kl.de:14
Index: Tst/Short/string.tst
===================================================================
--- Tst/Short/string.tst	(revision 0df02761ea5104747ff923eee578ddb4d27f4a45)
+++ Tst/Short/string.tst	(revision 458bd67f21def86763df6137584fe9c0d9fa9a66)
@@ -2,52 +2,103 @@
 tst_init();
 
-list l = 1, 2; string(l);
+
+proc MyPrint(def what)
+{
+   "what";
+   what;
+   "print(what)";
+   print(what);
+   "string(what)";
+   string(what);
+   "print(what, \"%s\")";
+   print(what, "%s");
+   "print(what, \"%p\")";
+   print(what, "%p");
+   "print(what, \"%t\")";
+   print(what, "%t");
+   "print(what, \"%;\")";
+   print(what, "%;");
+}
+
+list l = 1, 2; 
+MyPrint(l);
+l;
+
 list ll;
-string(ll);
-l = l = ll;
-l;
+MyPrint(ll);
+
+l = l + ll;
+MyPrint(l);
+
 l = insert(l, ll);
-l;
+MyPrint(l);
+
+l[10] = 5;
+
 string(l);
- l;
-l[10] = 5;
-string(l);
+MyPrint(l);
+
 l[3] = intvec(1,2,3);
 l[4] = "hi";
-string(l);
-l;
+MyPrint(l);
+
 l[6] = list("ho", "he");
-string(l);
- proc hi {1;};
-l[8] = hi;
-l;
-string(l);
+MyPrint(l);
+
+l[8] = MyPrint;
+MyPrint(l);
+
 link li = "/tmp";
-li;
-l[7] = li;
-l;
-string(l);
+l[8] = li;
+MyPrint(l);
+
 ring r;
+MyPrint(r);
+
 ideal i;
-string(i);
-string(r);
+MyPrint(i);
+
 l[8] = r;
 l[9] = i;
-l;
+MyPrint(l);
+
+matrix ma[2][2] = x,y,z,x2;
+MyPrint(ma);
+
+module m=[1,y],[0,x+z];
+MyPrint(m);
+
+l[1]= list(ma, m);
+MyPrint(l);
+
+intmat M=betti(mres(m,0));
+MyPrint(M);
+print(M,"betti");
+print(M, "%b");
+l[2] = M;
+MyPrint(l);
+ 
 ideal j = z2,x;
 resolution re = res(j,0);
-re;
-string(re);
+MyPrint(re);
 l[11] = re;
-l;
-string(l);
-string(l, l);
+MyPrint(re);
+
+matrix B(1..3);
+B(1)[1,1] = 1;
+B(2)[1,1] = 2;
+B(3)[1,1] = 3;
+
+B(1..3);
+print(B(1..3));
+string(B(1..3));
+
 qring qr = std(ideal(x,y));
-string(qr);
-l[12] = qr;
-l;
-string(l);
+MyPrint(qr);
+
 list l = 1, qr, list(2, qr);
-l;
-string(l);
+MyPrint(l);
+
+
 tst_status(1);$
+