Index: Tst/Old/m18ex.res.gz.uu
===================================================================
--- Tst/Old/m18ex.res.gz.uu	(revision 4d9dc5f3de1003bc5e3bf71c31ed7833ed17d937)
+++ Tst/Old/m18ex.res.gz.uu	(revision 559d1ee5651bb2aab60891dce7d68b2348256ca7)
@@ -1,32 +1,32 @@
 begin 640 m18ex.res.gz
-M'XL(""+=%#<``VTQ.&5X+G)E<P#=5UUKXT84?=>ON%GZX$12[!G)LI/@0$L+
-M&RBAL`NEE-U%EL>1J"RYFE$R"B6_O6=&LB0WV>R64@KU@W0U<^=^G+ESYOK=
-M^^]O;HF(7>/QX\UW]"8M2J%249WGV?K-E?.N4^!&83JE5?>C]ZF@K*K$IDZR
-M=2XHB:7H9_MEP3D>55;<D:05S;R)]II3;R,'PZ$QO"_SAK;0:$*?ZZ#A?JCG
-MC:LC7R\&U;E1S3.I*"V@NQ'W(B_WD^WIE9-.9J<88DX\81YOQ73"C,`QQKNQ
-M:6@_`O/ALRGO34?&M$S+ATE:_,H^G%X1M?F^C7?KNKH3E7_;XD*[6%69=C#7
-M2AX%.G!F'@0D2`21X:4[<1IZ1YX6QM,FD_L\;M[>_@!_QMF+GKH$Q4X4BAPH
-M([*5W[B/2/;L$=G9,8XQ[9K/C[Q[89*WD\&'%2*PWQ^YB:,5@SZ<I4U<J':/
-M!JPO1F'>%/=QE<6%DC9:AY(TKN)$B0I[D24D]+XL$*,DNJ30B[R%0W>B$%6L
-MRDI2N86#7797E?6>#BHL<.BG.I.BUK2/,ZB-?Y<T";!EDP4>#G"XJX0P=@`+
-M)66!FH-EJ\<B,Y^KF+)#E$=VE@Z<_UZ+(K$&=G6NLGV>)9G*A#2AH#0\=DB;
-MS;HRSXY3IH<LSZD2JJX*&\0P3[&T-=F;8*;D]P!HU^WMH90PIK(X;^<,XH^Q
-MRLK"A+4UY71V1C_'58&-N(0KB4@IDP`72!.04R65U09E,8=WTA07&UH8L:$3
-MYY,I#39ED0[]P+SF+O9=+S#!S404XBS-S6OA!M.`ZZ5KM2]0$TO-9GWT]IP_
-M^[71QSM2\6]"6@2VV#-%%@5S_(%";\,>^I=L")V(O;++;;VE6'7->R.RMQ#V
-MM"&T+<U52QV>.B(/-A_(8Z4#E^N&NPT?YJ,18ZQZOL"!-%7<@7U"OY0U0KD7
-M**1M5H@-H"YQN(MFB.S$H6]1`?WW.)46"?50ME6R1G7<%268\>0%6O*'6K-,
-M\&\6"A\*)3@J%%_QMC!\U3,!6XZP8B.P(A/:?X>6D<,#CS-$8X;#/NJ+,8AL
-MX.T8EA48ZJ\@_AW\HL\=-.#G<A7ZH8IZ'#$PQ\#B$!D?J$0J$6]@$\Z2<K>O
-ME2GL!C#NXL84N(`#`\V8[R][.Y9/NGWA*Z@?MB8M/,91R)]!R,A+(R^MR&8M
-MH%'[9>$-^FN)\S&.?(PC*-[NTS]%DXW*D3VKQP.>[E(M$:1B,S?@BO%G^$+A
-MPBHPJ]#7+P]>ZE"^T)_P@6BJ<7^R[RF$'U$,8SYO0)Y^$^B%#RER&W0J+L<S
-M<)NYYGX3#6NC0T@TT7.?-0#]#&+4]3A,\P:KPM-^P6*TURO$/FYQ<)T;!L!-
-M2^LJ+I*4MF5=;!P<PDP),M/M`-'3TU.W%9<@@4Y](N0IR3I)A)3;.D=";3'B
-M!$._#V%YW`E]53-DXF((&HZ2]*7.:.;9KDBWKX$#^:MMAN_[XXL63KK$BWJW
-M-A6%^QTZ_\=^Y,O)\Z])GGOSUU.W"J_F/?]BRN'K&?/7,Q[E._K!%C*2(K$7
-MW_&:-O&QLN-TV/QA7'+S<+HYUSX=,\3(SK.>](+9F/3`,X=+^-#N'-^]',35
-M^FE92W?DI.>]079]:'0,J>-DO6"&#;UBP,_;/UU*JO;_%H1/4L6JEFCDK[YQ
-3&%U?TS!X7M;*^1.UF_B3M`T`````
+M'XL("(KN7#<``VTQ.&5X+G)E<P#=5UUKY#84??>ON%GZ,(GMS$CV>"8)$VAI
+M80-E*>Q"*65W<3R:V-1C3RTYD4/9W]XC^7.:;'9+*87.@RU+5U?G'ET=W7G[
+M[ON;-T3$KO'X\>8[>I46I5"IJ,[S[/;5E?.V,^#&8#ZG3?>C=ZF@K*K$MDZR
+MVUQ0$DLQC`[3@G,\JJRX(TD;6G@S[36GWE:.CD/C^%#F#>U@T80^UT'#_5`O
+M&U='OEZ-IDMCFF=245K`=BON15X>9KO3*R>=+4[1Q9QXQCS>-M,9,PV./M[U
+MS4/[$9@/G\WYX#HRKF5:/LS2XE?V_O2*J(WW=;R_K:L[4?EO6EYH'ZLJTP[&
+MVI9'@0Z<A8<&`B1"D^&EN^8\].Q*Q_9?.:F'MS+PMID\Y''S^LT/`&D0/@NO
+M8T7L1:'(@3'"V?B-^PB&SAY!B>WCZ-.N^?S`NQ<&>3L8O-\`@?W^P`V.MAD,
+M<-:6+:':C1TWZ&("\Z:XCZLL+I2T:!U*TKB*$R4J;&"6D-"'L@!&271)H1=Y
+M*X?N1"&J6)65I'*'!?;97576!^I-6.#03W4F1:WI$&<PF_XN:19@GV<K/!SP
+M<%<)8?R`%DK*`HD*S]:.168\5S%E/<HC/VL'B_]>BR*Q#O9UKK)#GB69RH0T
+M4)!/'NO#9HON;&3'(=-#EN=4"557A04QCE,L;2(/+I@Y)P<0M._VML\_]*DL
+MSMLQP_ACK+*R,+!V)J?.SNCGN"JP$9=82@(I91+D@FD"<ZJDLMHB+998G33%
+MQ996IMG0B?/1I`:;LTB'?F!>2Q?[KE<8X&8@"G$`E^:U<H-YP/7:M=87R(FU
+M9HL!O16')[\6?;PG%?\FI&5@ASU39%DPF@$6!A]6*9[S(70B#LI.M_F68M8U
+M'YS(P4,X:(W0-C4WK=YXZDAQV')4G(T.7*X;[C9\'(\F,K,91`8'TF1Q1_8)
+M_5+6@'(OD$B[K!!;4%WBA!?-B.S$H6^1`</W-)26"?50MEERB^RX*TK(Z<DS
+M6N:/N6:5X-],%#XF2G"4*+[B;6+X:E`"MIYPQ29D10;:?\>6:8>]^#.@,=WA
+M@/IB2B(;Q3Z&9P6%^BN)?X>_Z','#?RY7(5^J**!1W0LT;'JD?%12J02\18^
+ML5A2[@^U,HG=@,9]W)@$%UC`4#/5^\O!C]63;E_X!N;]UJ2%QS@2^3,,F?;:
+MM->VR18MH5'[9>D-AFN)\RF/?,HC)-[NTS]EDTW2D3W)QYY/=ZW6`*G8P@VX
+M8OP)OS"XL`;,&@SYRX/GRIHO%#5\%)IJ6M0<!@GA1Q+#F,\;B*??!'KEHQ6Y
+M#<H;E^,9N,U2<[^)QKE1#XEF>NFS!J2?H1EUA1'3O,&L\'28L)KL]0;8IW41
+MKG.C`+AIZ;:*BR2E75D76P>',%."S'#;0?3ITZ=N*RXA`IWY3,A3DG62""EW
+M=8Z`VF3$"8;]`&%]7#Y]505E<#&`QD))^EPYM?!L5:3;%T[UYTJH)X8]K!?K
+M$=_WIS<RT'0,%?7^UJ0>"@'8_!\+ER\'S[\F>.XM7P[=&KP8]_*+(8<O1\Q?
+MCG@2[^0'7XA(BL3>D,=SVL"GQH[3<?.'69*;A].-N?;IF"Y&=IP-ZA@LINH(
+M0>IOZ[XN.KZD.12N7:>5-]VIF%X.#MEU7Q$9]<<1?,8-&XO*@)^W?^F45.V_
+?.30^2A6K6J+BO_K&871]36/G>5DKYT_V[;8]$@X`````
 `
 end
Index: Tst/Old/m18ex.stat
===================================================================
--- Tst/Old/m18ex.stat	(revision 4d9dc5f3de1003bc5e3bf71c31ed7833ed17d937)
+++ Tst/Old/m18ex.stat	(revision 559d1ee5651bb2aab60891dce7d68b2348256ca7)
@@ -1,4 +1,4 @@
-1 >> tst_memory_0 :: nepomuck.mathematik.uni-kl.de:338646
-1 >> tst_memory_1 :: nepomuck.mathematik.uni-kl.de:410178
-1 >> tst_memory_2 :: nepomuck.mathematik.uni-kl.de:479232
-1 >> tst_timer_1 :: nepomuck.mathematik.uni-kl.de:74
+1 >> tst_memory_0 :: nepomuck.mathematik.uni-kl.de:340141
+1 >> tst_memory_1 :: nepomuck.mathematik.uni-kl.de:411025
+1 >> tst_memory_2 :: nepomuck.mathematik.uni-kl.de:507904
+1 >> tst_timer_1 :: nepomuck.mathematik.uni-kl.de:76
Index: Tst/Old/ringlib.res.gz.uu
===================================================================
--- Tst/Old/ringlib.res.gz.uu	(revision 4d9dc5f3de1003bc5e3bf71c31ed7833ed17d937)
+++ Tst/Old/ringlib.res.gz.uu	(revision 559d1ee5651bb2aab60891dce7d68b2348256ca7)
@@ -1,54 +1,55 @@
 begin 640 ringlib.res.gz
-M'XL("-/)+#8``W)I;F=L:6(N<F5S`-U:;7.C.!+^[E^AHZYJ8:,X1MBSNTXY
-M5=F9N;O9VME*;'^XJJE,"@..F<%`$,8X]^>WU1(&;!R<M[JM]0<(DKK5W7H>
-MJ25E,OWPZ0]"B'E!?O_T*]$2/[SK!OY,.^],5!6[(%YN+^/`(\["#N\\>";G
-MG;,S$B>14RDC\R1:$A`FA9;.Q_]>?K[Z_>.P`WI$(4E&/:KG=$-7-#.H[L8Z
-M,ZC+C7/1HE2E:V.-:HQ>:L8Y&9]K&O:'+1+;2;W$YZGOD"%ALMPD,50L/:B!
-M+RB_)+)BZ8=Q%&R(^@U)3Y:'J^4,VD9SDMD)A_*^+,??+(B<[ZAU2*+$]=!R
-M-ZZT*']#$D*_7/R9DPUIT,)J6GB;EA7)FK1852WO.WOA,B%>%NOU+(V.1<S,
-M0Q'#1G^/($#)=S\(R)@*=^'+G^M\PU-OJ6MK/UU`2/X0&F/;\;AF&.1_':D/
-MI:91/!R.J7R!_!;PUB[@H<M=O$/1*\$=-$FTKZ&26E`=2]"3PZA_-HC73QV_
-M:INUY]\M4BX&TVH?X]:>C@>Z[WIV0'PR(OE71C=?V>GJJT4S#.(]MKN&.IZZ
-MNK\7V>L?(+1!K-%K".KU#Z\>T>"HB![PE=5]A0;WJRCUO3"5\$&$H?>=VR_F
-MS2B#%[L9Y0S>ULUH`X&P*BRXIL+!E_!`R&]YT-_E0;8_[V>O,.T_>7BYEXIB
-M/:F.=E:L&I>Z\78$:H?UI6X:\&#&*TR#E[HE=/4;=1U<$3`2B'N;SJA#W3<#
-M?WLT;#)[A3@XQ#TB`JWT<25];$6?&3MUWI`^@Y(^KC<7!I7D404MU%&M="T!
-M$WH:'5!M)68S+O"=/`??@];I[*BE>7W4,B\QN76BR.BHV:-:KL,73`.PWJVY
-M;E*Y\G%)W+?.]<S>*^0Y@N:YH'DN2-H6BW5K7'-!\UP?B,<[HW4-1HNQ%R1"
-M&SO:.9;K/XFN?Q:/7\3#[#6ZU6_.P1(Z?B9W$I6"5:CS;H\Z?(\[_#CR<'U`
-M>X"JR>!-^')$7($I#T?-@S6^<-U"LZW><Q)YJQWA1P"BAO`=?#;"!9XH8Z*0
-MB5(FBIDH9Z*@B9(FBIHHRU"6R?Y0EJ$L0UF&L@QE&<HRE&4H:S7#E#7#=#*@
-M,J;/@BI(R[?0L$7K3WMHC??0&A^'UEBA]>J-T'I4LOH,M,82K5=OAM:GSL=_
-M#[1>`5JOGHW6*X76JQI:?R[1ZN6I%[KUS*0L>U)>_R!6;YF<+Z*UR,P5?$6S
-M(=%[QK:=[G*Q[+\WL+Y8M$>`:B%^=A9&Q`_3S'/(G9]Y(250@''B_H,GRX:5
-M`I\3$;?,4QMR:*V0A5&#7#`=#="RTC5Y7I)"@HQ9B,@ZBM_964KN@FAF!T,B
-MJLCIA7@#DK2M=V/3V-*SXI_*MJE'MYX*.?JHOS6CF$;[5)N*W,@1YP#4I(FT
-M[>QL:XQ#NUVH!(!7+&('`TZGP`QX,/&PQ*-O0)VCS$)%#:8=&(N]@<!7?3A6
-MW'/W7+-*UW#WI]&>\@UZ5D5%K%G5,ZO)LP:?JD''S:4(?5/0I6=5M\JTR@[=
-M1Z`E?9624HL.`>*QY_ASW[%3/PH%]NRJBI"D"Q4LP7">)D*M'031VG/_82AC
-MYD68W0BFLS!*B1-E,$="NUJ$*6H+;)ZJJ4.%F\RC1*H2]8FWM/U0\!-HX-NS
-MP`/!LH^%S4D:161IAQOH9QE'(6R9*KJE)B@%0Q/PX2Z,$CFD2D,VLD3&#B-J
-M4FN?6WV9XU^*L>:0W],/,:(YDV/>J9`MDXYRR%:EAT.2P5:-Z".84H>*S*6-
-MXFO-JPI"Z%F*9':P`HOU4?:%=;O]&P,C5PQM5::,3UUSANX6\23U4$KS2ESV
-MC5U07M)?Z7OZ@7ZD_Z+_IO^AG^AOM#+GF;C5P;`9$!%%/NN1^8&4N;5)QXR.
-M+3KN/W>':JHTFZFWI=[]RMKP2[DVS+T4UO`@*%>&HN2Q=0':3A>`R4*++\'L
-MY9ZS2B&LW`^=4G>)]G64?!=<L;$KSUTEGM"E"SXN/"$C6BDR%<JW38TN^6T%
-ME$B3#3:81X)>:GP!Y2XO5ZQQ=<6**^=/WT90RN@#P[*EG29^3CY_83?BJ``W
-MJ'(PL?K;.?0.9-`_2SBCZHE0C8O`=C$L/-7'E24&I[REK5+",7"13(8D/[VP
-M*=F<7LPH>3B]P`D&LQM]8C3VN=4]H9I9+F&@&QP*4S_=8">`:]#N1/&&1+-O
-MGB.(+L^)I/J]?M1IR&1[`V3V2ECXH+*&"E7P<E`4BOZOF*"K)E2(<G:RRD\>
-M'L?&ZBAP0-,'NME"1/E]'$)R1,@&$?)`R>KTHM>*DZ*#-X>)6<)D%R6O!9*_
-M`D::$7+,K"'B'"_\T9CF3,TUY+'90QV,CQP*Y84&Q`KU:V@YB!<'\6(C7F:/
-M(D48=E[1!I^8J#2K95(ODXI9Q5AS!*7VR8R:.P:;5*OGV<U3H-)\(F=!<]_F
-MVZW1M]+JV]U+@*DFSA<->1$J.E(XQMTF8&&,:9XC@)1X?!6D9%HS=6GGZ`RL
-MV$6"6J-*:?.T-&]Z(*15JM!I29;*K;H8?LB>>%2Y72G+CMN&X?:Z<L6B((JU
-MO(*L=:P.6\OJ%*IA:]OM#G!;$/"R3EJ`1[<)Y325->DF]M0I[9@T_+[T;@CY
-M4<@_XRS`9*]SB'',C5O[;:@X"'%:SV+-0S>BM2/8]J/U@V<81QW#JELQ4IL[
-M((^TV<G,.G$&NS29")J(N:FZ*(`2,B%ZE3$P-F*_0.3DAQ/ES.;8<7E#=S\A
-M(W%#ATF)SF%^*O:M3N+9J:>:B56&+",7#-.!2C"O"^8;#006V^@YO:.0VP+L
-ME&73/<M2H<#M=A<'#9NB72X[\=CIW*JXNFO8%`TK&NY2X%H#`MQ/:$KOIQ4:
-M7",-KO>'M:#!_2,\.'@_\>[E]_@O1.X3>2*/#?_R/&E7[1)(`\@=633I&CSQ
-MOG%NG0*67":O'1\&)QOK)&>U&T=<$\A+KAS5B;1\3<O-G&FI?^E*>2K_HPO^
->N.6IG:[$7O3\GQV37%R0LK`;K=+.GTW]&&D0)@``
+M'XL("%SN7#<``W)I;F=L:6(N<F5S`-U:;6_C-A+^[E_!$PZHU#".1=G;UH$#
+MI+M[=UMTB\3VAP,6V4"6Y%B[LJ2(LBS[_GR'0\J2_!(Y3H(KZ@^237*&P^'S
+M#(>D1^,/G_X@A)A7Y/=/OQ(M\<.'=N!/M,O62%6Q*^+E]CP./.+,[/#!@V=R
+MV;JX('$2.94R,DVB.0%A4FAI??SO]>>;WS_V6Z!'%))DT*%Z3E=T03.#ZFZL
+M,X.ZW+@4+4I5NC;4J,;HM69<DN&EIF%_V"*QG=1+?)[Z#ND3)LM-$D/%W(,:
+M^`7EUT16S/TPCH(549\^Z<CR<#&?0-MH2C([X5#>E>7XF021\QVU]DF4N!Y:
+M[L:5%N6G3T+HEXNO.5F1/5I830MOTK(@V3XM5E7+^]:.NTSPE\4Z'4NC0^$S
+M\Y#'L-'?PPE0\MT/`C*D8KCPRY_J?,53;ZYK2S^=@4O^$!ICV_&X9ACD?RVI
+M#Z7&4=SO#ZE\@?P&\-8VX*'+;;Q#T2O!'31)M"^ADEI0'4O0D\.H/QG$R^?.
+M7[7-TO,?9BD7DVDUSW%C3\<#W7<].R`^&9#\*Z.KK^Q\\=6B&3KQ$=O=0AU/
+M7=W?\>SM#^#:(-;H+3CU]H=7]VAPE$</C)75QPH-'A=1ZGMA*N&#",/1M^Z_
+MF'>##%[L;I`S>%MW@Q4XPJJPX):*`;Z$!T)^PX/N-@^RW;B?O4+8?_;T<B\5
+MQ7I2G>VL6#6N=>/M"-0,ZVO=-.#!C%<(@]>Z)71U]^HZN"*@)Q#W-IU0A[IO
+M!OYF;]AD\@I^<(A[A`<:Z>-*^MB*/A-V[KPA?7HE?5QO*@PJR:,*&JBC6NE:
+M`B9T--JCVD)$,R[PG9R"[UYC.#MJ:5X>M<Q+3&X&461TU.Q0+=?A%X0!6.^6
+M7#>I7/FX).Y;YWIFYQ7R'$'S7-`\%R1M\L6RT:^YH'FN]\3CG=&X!J/%V`L2
+MH8D=S1S+]9]$US^+QR_B87;V#JN[/P=+Z/!$[B0J!:M0Y]T.=?@.=_AQY.%Z
+MCW8`5:/>F_#E"+\"4]9'Q<$:7[ANH=E6YY1$WFI&^!&`J"%\"Y][X0)/E#%1
+MR$0I$\5,E#-1T$1)$T5-E&4HRV1_*,M0EJ$L0UF&L@QE&<HRE+7VPY3MA^FH
+M1Z5/3X(J2,NWT+!!ZT\[:(UWT!H?A]98H?7FC=!Z5+)Z`EICB=:;-T/K<^/Q
+MWP.M-X#6FY/1>J/0>E-#Z\\E6KT\]4*WGIF49<_*Z]=B]9;)^2Q:BLQ<P5<T
+MZQ.]8VS:Z2X7R_Y[`^N+17L@41U-OGD.K&\3+XC"!]%%&I%TYG.I"#%W<1%&
+MQ`_3S'/(@Y]Y(250@*[D_MJ39?U*`4@+UV:>VK-#:P4^="RDB^F@A\:7HY='
+M*BGDT)BHB,2D^%Q<I.0AB"9VT">BBIQ?B3>`3=LX8&@:&P977*`2<NK1C3.$
+M''VI2VIV,XUVJ386&98C3A.H21-I_L7%QEZ'MMM0"32I&,T.3AL=`[_@P<3#
+M$H^N`76.LAP5G6;]@1G=F4Y\U2=UP3UW9_16.7K<9FJTHX8/UJBB8L98=?#6
+MOL'O&79UZG`7*R;PQ*F3@Z^.O$SQ[-!]`L/2'5)2:M'!ASSV''_J.W;J1Z$`
+MN5U5$4+?RI\BVO`T$6KM((B6GOL/0QDS+6;"C2"TAE%*G"B#>`WM:I-`45M@
+M\U2%,34C9!HE4I6H3[RY[8=BZ,`WWYX$'@B6?<QL#CZ)R-P.5]#//(Y"V+Y5
+M=$M-4`J&)C"&AS!*Y*PK#=G`$KL'F'236KLD[LK]QK6``X>]!OT0(R<R"8M6
+MA=69'"B'S%F.L$\RV#82?0#AO:^B1FFC^+7D504A]"Q%,CM8@,7Z(/O"VNWN
+MG8&>*Z:V*E/ZIZXYP^$6_B1U5TKS2NAVC6W<7M-?Z7OZ@7ZD_Z+_IO^AG^AO
+MM!)_3=QVH=L,\(BBL/6R0$3*K8!)AXP.+3KLGKJA-M6N@*FWI=[=RE+V2[F4
+M3;T44HX@*!>RHN2I90S:CH7]A19?XMW+/6>1@N>Y'SJE[I(0RRCY+NAD8U>>
+MNT@\H4L7E)UY0D:T4GPKE&^:&FWRVP)8DR8K;#"-!`,5!(`(+B\7V&%U@8TK
+MQV7?!E#*Z)IAV=Q.$S\GG[^P.W&R@?MI.=]8_>T2>@>^Z)\EXE'U2*C&!6FS
+M=A<CU8>5Y0X#Y]Q6&>Q03/JH3_+S*YN2U?G5A)+U^17&($S&])&QM\^-[A'5
+MS'(Y!=TPH##UTQ5V`M`'[4X4KPJ\476L)=7O]*,.;T:;"RNS4\+"!Y4U5*B"
+MEX.B4/1_Q01=[$.%*&=GB_QL_30V%D>!`YJNZ6H#$37NXQ"2(T)6B)`U)8OS
+MJTXC3HH.WAPF9@F3;92\%DC^"AC9CY!CHH;P<SSS!T.:,Q5KR%/10YWC#QP*
+MY84&Q`KU:V@YB!<'\6(C7B9/(D48=EG1!C\QE]FOEDF]3"IF%6/-`93:9Q-J
+M;AEL4JV>\^\/@4KSF8R"YJ[-]QNC[Z75]]MW%F--'(<:\MY6=*1PC)MCP,(0
+M,T%'`"GQ^")(R;AFZMS.<3"PJ!=I;HTJI<WCTKSQ`9=6J4+')5DJ?P(0TP\)
+M%H\JET%EV7&[1CP-J-P(*8AB+:\@:QFKL^&R.H5JV(FWVSW<?P2\K),6X$ES
+M0CE-94VZBCUUJ#PD>SY?.G>$_"CD3SBZ,-GKG+D<<T'8?'DKSFV<QJ-C\]`%
+M;NW$N/DFX."1RU&GQNH2C]1B!Z2:-CN;6&=.;YLF(T$3$9NJBP(H(2.B5QD#
+M<R.V%$0&/PR4$YMCQ^6%XN.(#,2%(B8E.H?X5&R0G<2S4T\U$ZL,F4<N&*8#
+ME2"N"^8;>P@LMO13^D`AMP78*<O&.Y:E0H';;L\.&C9&NUQVYK'SJ549ZK9A
+M8S2L:+A-@5L-"/`XHBE]'%=H<(LTN-V=UH(&CT_PX.!URKN7_^W@A<A])D_D
+M*>=?GB?-JET":0!Y(+-]NGK/O!Z=6N>`)9?)6])U[VQEG>6L=D&*:P)YR0VI
+M.D"7KW&YF3,M]0^TE*?R#VCPY9ZG=KH0V]7+?[9,<G5%RL)VM$A;?P+.3!0[
+$OR8`````
 `
 end
Index: Tst/Old/ringlib.stat
===================================================================
--- Tst/Old/ringlib.stat	(revision 4d9dc5f3de1003bc5e3bf71c31ed7833ed17d937)
+++ Tst/Old/ringlib.stat	(revision 559d1ee5651bb2aab60891dce7d68b2348256ca7)
@@ -1,4 +1,4 @@
-1 >> tst_memory_0 :: urmel:282438  nepomuck.mathematik.uni-kl.de:275950
-1 >> tst_memory_1 :: urmel:293358  nepomuck.mathematik.uni-kl.de:297454
-1 >> tst_memory_2 :: urmel:401408  nepomuck.mathematik.uni-kl.de:323584
-1 >> tst_timer_1 :: urmel:75  nepomuck.mathematik.uni-kl.de:23
+1 >> tst_memory_0 :: nepomuck.mathematik.uni-kl.de:267053
+1 >> tst_memory_1 :: nepomuck.mathematik.uni-kl.de:330973
+1 >> tst_memory_2 :: nepomuck.mathematik.uni-kl.de:331776
+1 >> tst_timer_1 :: nepomuck.mathematik.uni-kl.de:28